'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _child_process = require('child_process');

var _portscanner = require('portscanner');

var _portscanner2 = _interopRequireDefault(_portscanner);

var _ip = require('ip');

var _ip2 = _interopRequireDefault(_ip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var VORLON_PATH = _path2.default.join(__dirname, '../vorlon');
var VORLON_BIN = _path2.default.join(VORLON_PATH, '/bin/vorlon');
var CONFIGURE_FILE = _path2.default.join(VORLON_PATH, '/Server/config.json');
var CONFIGURE_BAK_FILE = CONFIGURE_FILE + '.bak';
var VORLON_PARAMS = ['port', 'proxyPort', 'state'];

var Vorlon = function () {
  _createClass(Vorlon, [{
    key: '_defaults',
    value: function _defaults() {
      var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      return Object.assign({}, this.setting, options);
    }
  }]);

  function Vorlon() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, Vorlon);

    this.setting = {
      runServer: true,
      appendScriptTag: true,
      port: undefined,
      proxyPort: undefined,
      state: ''
    };

    this.setting = this._defaults(options);
  }

  _createClass(Vorlon, [{
    key: 'apply',
    value: function apply(compiler) {
      var options = this._defaults();

      this.compiler = compiler;

      options.runServer && compiler.plugin('watch-run', this.start.bind(this));
      compiler.plugin('compilation', this.applyCompilation.bind(this));
    }
  }, {
    key: 'applyCompilation',
    value: function applyCompilation(compilation) {
      compilation.mainTemplate.plugin('startup', this.scriptTag.bind(this));
    }
  }, {
    key: 'start',
    value: function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(watching, done) {
        var _this = this;

        var defaults, idlePort, idleProxyPort, options, buffer, source, params, childProgress;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                defaults = this.setting;
                _context.t0 = defaults.idlePort;

                if (_context.t0) {
                  _context.next = 6;
                  break;
                }

                _context.next = 5;
                return getIdlePort();

              case 5:
                _context.t0 = _context.sent;

              case 6:
                idlePort = _context.t0;
                _context.t1 = defaults.idleProxyPort;

                if (_context.t1) {
                  _context.next = 12;
                  break;
                }

                _context.next = 11;
                return getIdlePort(idlePort + 1);

              case 11:
                _context.t1 = _context.sent;

              case 12:
                idleProxyPort = _context.t1;
                options = this._defaults({
                  port: idlePort,
                  proxyPort: idleProxyPort
                });

                /**
                 * Vorlon 没有配置项
                 * 因此必须修改 /path/to/vorlon/Server/config.json 里面
                 * 进行配置项修改
                 *
                 * 这里会保存原先的文件到 .bak 里面, 写入新的配置到配置文件中
                 */

                if (!_fs2.default.existsSync(CONFIGURE_BAK_FILE)) {
                  _fs2.default.copySync(CONFIGURE_FILE, CONFIGURE_BAK_FILE);
                }

                buffer = _fs2.default.readFileSync(CONFIGURE_FILE);
                source = JSON.parse(buffer);


                Object.assign(source, options);
                _fs2.default.writeFileSync(CONFIGURE_FILE, JSON.stringify(source));

                /**
                 * 启动 vorlon
                 */

                params = VORLON_PARAMS.map(function (key) {
                  return '--' + key + ' ' + options[key];
                }).join(' ').split(' ');
                childProgress = (0, _child_process.spawn)(VORLON_BIN, params, {
                  stdio: 'inherit'
                });


                childProgress.on('close', function () {
                  _this.reset();
                });

                this.server = childProgress;
                this.serverOptions = options;

                done();

              case 25:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function start(_x3, _x4) {
        return _ref.apply(this, arguments);
      }

      return start;
    }()
  }, {
    key: 'scriptTag',
    value: function scriptTag(source) {
      var options = this.serverOptions || this.setting || {};

      if (options.appendScriptTag) {
        var injector = this.autoloadScript();
        return injector + source;
      }

      return source;
    }
  }, {
    key: 'autoloadScript',
    value: function autoloadScript() {
      var options = this.serverOptions || this.setting || {};
      var servPort = options.port;

      if ('number' !== typeof servPort) {
        return logger('error')('No script tag will inserted, because the config is not run vorlon server `(runServer)`, and you also do not configure `port` and `proxyPort`.');
      }

      var servIp = _ip2.default.address();
      var client = 'http://' + servIp + ':' + servPort + '/vorlon.js';
      var server = 'http://' + servIp + ':' + servPort + '/dashboard';

      return '\n      // Vorlon plugin\n      !(function () {\n        if (\'undefined\' === typeof window) {\n          return;\n        }\n\n        var id = \'webpack-vorlon-plugin-script\';\n        var vorlon = document.createElement(\'script\');\n        vorlon.id  = id;\n        vorlon.src = \'' + client + '\';\n        document.head.appendChild(vorlon);\n      })();\n\n      ' + logger()('`Vorlon Server`: ' + server) + '\n    ';

      function logger() {
        var type = arguments.length <= 0 || arguments[0] === undefined ? 'log' : arguments[0];

        return function () {
          var colors = [];

          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          var params = args.map(function (param) {
            while (/`([\w\W]+?)`/.exec(param)) {
              param = param.replace(/`([\w\W]+?)`/, '%c$1%c');
              colors.push('"color:#0073b7;font-weight:bolder;"', '""');
            }

            return '"' + param + '"';
          });

          params = params.concat(colors);

          return '\n          !(function () {\n            if (\'undefined\' === typeof window) {\n              return;\n            }\n\n            var log = document.createElement(\'script\');\n            log.innerHTML = \'"function" === typeof console.' + type + ' && console.' + type + '(' + params + ')\';\n            document.head.appendChild(log);\n          })();\n        ';

          return '';
        };
      }
    }
  }, {
    key: 'reset',
    value: function reset() {
      if (this.server) {
        this.server.kill();

        if (_fs2.default.existsSync(CONFIGURE_BAK_FILE)) {
          _fs2.default.copySync(CONFIGURE_FILE, CONFIGURE_BAK_FILE);
        }

        this.server = undefined;
        this.serverOptions = undefined;
      }
    }
  }]);

  return Vorlon;
}();

exports.default = Vorlon;


function getIdlePort() {
  var port = arguments.length <= 0 || arguments[0] === undefined ? 50000 : arguments[0];

  return new Promise(function (resolve, reject) {
    _portscanner2.default.findAPortNotInUse(port, port + 10000, '0.0.0.0', function (error, port) {
      error ? reject(error) : resolve(port);
    });
  });
}

//# sourceMappingURL=index.js.map